
#include <Adafruit_NeoPixel.h>
#include "Water.h"
#include <PinChangeInt.h>



Adafruit_NeoPixel Rings = Adafruit_NeoPixel(PIXEL_NUM, LEDS_PIN, NEO_GRB + NEO_KHZ800);

uint8_t State = 0;
uint16_t WaterVolume = 0;

void setup()
{
  digitalWrite(START_PIN, HIGH);
  pinMode(ACT_PIN, OUTPUT);
  digitalWrite(ACT_PIN, LOW);

  PCintPort::attachInterrupt(START_PIN, &START_ISR, FALLING);
  
  Rings.begin();
  for(byte i=PIXEL_IN_SMALL_RING; i < PIXEL_NUM; i++)
      Rings.setPixelColor(i, BACKGROUND_COLOUR);
  Rings.show();

  //Serial.begin(115200);
}
//----------------------------------------
void loop()
{
  if ((State & PROCESS) != PROCESS)
  {
    uint16_t Data = analogRead(VOLUME_PIN);
    
    if (abs(Data - WaterVolume) >= DataThreshold)
    {
      WaterVolume = Data;
         
      //if (DataPrev < DataThreshold)
        //DataPrev = DataThreshold;

      if (WaterVolume > 975)
        WaterVolume = 1024;
      
      for(byte i=PIXEL_IN_SMALL_RING; i < PIXEL_NUM; i++)
        Rings.setPixelColor(i, BACKGROUND_COLOUR);
      for(byte i=PIXEL_IN_SMALL_RING; i < (PIXEL_IN_SMALL_RING + (WaterVolume / DataThreshold)); i++)
        Rings.setPixelColor(i, PROCESS_COLOUR);
      Rings.show();
      //DataPrev = Data;
    }
  }

  else
  {
    float Volume = (float)((WaterVolume * MAX_VOLUME) / 1024);
    uint8_t LEDPos = 0;
    uint8_t VolCnt = 0;

    for(byte i=PIXEL_IN_SMALL_RING; i < (PIXEL_IN_SMALL_RING + (WaterVolume / DataThreshold)); i++)
      Rings.setPixelColor(i, SHADOW_COLOUR);
    Rings.show();
    
    digitalWrite(ACT_PIN, HIGH);
    
    while (Volume >= MIN_VOLUME)
    {
      delay(mlToTimeCoef * MIN_VOLUME);
      Volume -= MIN_VOLUME;

      VolCnt += MIN_VOLUME;
      {
        if (VolCnt >= MIN_VAL_FOR_LED)
        {
          LEDPos++;
          for(byte i=PIXEL_IN_SMALL_RING; i < (PIXEL_IN_SMALL_RING + LEDPos); i++)
            Rings.setPixelColor(i, PROCESS_COLOUR);
          Rings.show();
          VolCnt = 0;
        }
      }
    }

    digitalWrite(ACT_PIN, LOW);
    
    State &= ~PROCESS;
  }
}
//----------------------------------------
void START_ISR()
{
  State |= PROCESS;
}










